Package org.apache.sling.feature.maven

# Class Preprocessor

java.lang.Object
org.apache.sling.feature.maven.Preprocessor

public class Preprocessor extends Object
The processor processes all feature projects.

## Constructor Summary

Constructors
Constructor
Description
`Preprocessor()`

## Method Summary

Modifier and Type
Method
Description
`protected org.apache.sling.feature.builder.FeatureProvider`
`createFeatureProvider(Environment env, FeatureProjectInfo info, boolean isTest, boolean skipAddDependencies, String dependencyScope, List<org.apache.sling.feature.Feature> projectFeatures)`
`protected org.apache.sling.feature.Feature`
`postProcessReadFeature(org.apache.sling.feature.Feature result)`
Hook to post process the local feature
`protected String`
`preprocessFeature(org.apache.maven.project.MavenProject project, boolean validate, File file, String json)`
`void`
`process(Environment env)`
Process the provided projects.
`protected void`
`readProjectFeatures(org.codehaus.plexus.logging.Logger logger, FeatureProjectInfo info, FeatureProjectConfig config)`
Read the features for a feature project.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Preprocessor

public Preprocessor()

## Method Details

### process

public void process(Environment env)
Process the provided projects.

Parameters:
  `env` - The environment with all maven settings and projects

### readProjectFeatures

protected void readProjectFeatures(org.codehaus.plexus.logging.Logger logger, FeatureProjectInfo info, FeatureProjectConfig config)
Read the features for a feature project. The feature is either inlined in the pom or stored in a file in the project.

Parameters:
  `logger` - The logger
  `info` - The project info
  `config` - The configuration

### preprocessFeature

protected String preprocessFeature(org.apache.maven.project.MavenProject project, boolean validate, File file, String json)

### postProcessReadFeature

protected org.apache.sling.feature.Feature postProcessReadFeature(org.apache.sling.feature.Feature result)
Hook to post process the local feature

Parameters:
  `result` - The read feature
Returns:
  The post processed feature

### createFeatureProvider

protected org.apache.sling.feature.builder.FeatureProvider createFeatureProvider(Environment env, FeatureProjectInfo info, boolean isTest, boolean skipAddDependencies, String dependencyScope, List<org.apache.sling.feature.Feature> projectFeatures)